unit UnidadFiltros;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, ValEdit, ActnList, ExtCtrls;

type
  TformFiltros = class(TForm)
    BitBtn1: TBitBtn;
    tabla: TValueListEditor;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    ActionList1: TActionList;
    actNuevoFiltro: TAction;
    actAceptar: TAction;
    SpeedButton2: TSpeedButton;
    actEliminarFiltro: TAction;
    txtCombinacion: TComboBox;
    Label1: TLabel;
    dlAbrir: TOpenDialog;
    actCargarCombinacion: TAction;
    Button2: TButton;
    actGuardarCombinacion: TAction;
    actEliminarTodos: TAction;
    SpeedButton3: TSpeedButton;
    bAceptar: TBitBtn;
    actCargarCombinacionUbicacion: TAction;
    Button3: TButton;
    actGuardarCombinacionComo: TAction;
    Button1: TButton;
    StaticText1: TStaticText;
    txtEjemplo: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    txtResultado: TEdit;
    procedure actNuevoFiltroExecute(Sender: TObject);
    procedure actAceptarExecute(Sender: TObject);
    procedure actCargarCombinacionExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure actEliminarFiltroExecute(Sender: TObject);
    procedure actGuardarCombinacionExecute(Sender: TObject);
    procedure actEliminarTodosExecute(Sender: TObject);
    procedure actCargarCombinacionUbicacionExecute(Sender: TObject);
    procedure actGuardarCombinacionComoExecute(Sender: TObject);
    procedure aplicarFiltrosEjemplo();
    procedure tablaStringsChange(Sender: TObject);
    procedure txtEjemploChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formFiltros: TformFiltros;

implementation

uses UnidadSeleccionFiltros, UnidadMenuPrincipal, UnidadValor;

{$R *.dfm}


function guardarCombinacionFiltros (nombre : string; tabla : TStrings) : boolean;
var
  seguir : boolean;
  fichero : string;
begin
  result := false;
  if nombre <> '' then
  begin
    seguir := false;
    fichero := ExtractFilePath(Application.ExeName) + nombre + '.flt';
    if FileExists(fichero) then
    begin
      if MessageDlg('La combinacin de filtros ' + chr(13) + chr(13) +
           fichero + chr(13) + chr(13) + 'ya existe desea reemplazarla?',
           mtConfirmation, [mbyes, mbno], 0) = mryes then
        seguir := true;
    end
    else
      seguir := true;
    if seguir then
    begin
      tabla.SaveToFile(fichero);
      Result := true;
    end;
  end
  else
  begin
    MessageDlg('Debe especificar un nombre para guardar la combinacin de filtros', mtwarning, [mbok], 0);
  end;
end;

procedure TformFiltros.aplicarFiltrosEjemplo();
var
  i : integer;
  regla : string;
  valorRegla : string;
  ficheroResultante, ficheroActualSinRuta, ficheroActualSinExtension,
      extensionResultante, extensionActual : string;
begin
  try
    ficheroActualSinRuta := ExtractFileName(txtEjemplo.Text);
    ficheroActualSinExtension := extraerSoloNombreFichero(txtEjemplo.Text);
    extensionActual := ExtractFileExt(txtEjemplo.Text);
    //le quitamos el punto a la extensin
    if Length(extensionActual) > 0 then
      if extensionActual[1] = '.' then
        extensionActual := copy (extensionActual, 2, length(extensionActual));

    ficheroResultante := ficheroActualSinExtension;
    extensionResultante := extensionActual;
    //empezamos a aplicar las reglas seleccionadas
    for i := 0 to tabla.Strings.Count - 1 do
    begin
      regla := tabla.Strings[i];
      //puesto que el valor se separa con "=" buscamos el primer "=" que aparezca
      //pues en la clave (primera columna) no hay "="
      valorRegla := copy (regla, pos ('=', regla) + 1, length (regla));
      regla := copy (regla, 1, pos ('=', regla) - 1);

      if regla = 'Aadir texto al final' then
        ficheroResultante := insertarTextoAlFinal (ficheroResultante, valorRegla);

      if regla = 'Aadir texto al principio' then
        ficheroResultante := insertarTextoAlPrincipio(ficheroResultante, valorRegla);

      if regla = 'Cambiar la extensin' then
        extensionResultante := cambiarExtensionFichero (valorRegla);

      if regla = 'Colocar nmero automtico al final' then
        ficheroResultante := insertarNumeroAutomaticoFinal (1, 10, ficheroResultante);

      if regla = 'Colocar nmero automtico al principio' then
        ficheroResultante := insertarNumeroAutomaticoInicio (1, 10, ficheroResultante);

      if regla = 'Primera letra de cada palabra en maysculas' then
        ficheroResultante := primeraLetraPalabrasMayuscula (ficheroResultante);

      if regla = 'Primera letra en maysculas' then
        ficheroResultante := primeraLetraFicheroMayuscula (ficheroResultante);

      if regla = 'Suprimir los primeros caracteres' then
      begin
        try
          ficheroResultante := suprimirPrimerosCaracteres (ficheroResultante, strtoint(valorRegla));
        except
        end;
      end;

      if regla = 'Suprimir los ltimos caracteres' then
      begin
        try
          ficheroResultante := suprimirUltimosCaracteres (ficheroResultante, strtoint(valorRegla));
        except
        end;
      end;

      if regla = 'Suprimir texto especificado' then
        ficheroResultante := suprimirTextoEspecificado (ficheroResultante, valorRegla);

      if regla = 'Suprimir todos los nmeros' then
        ficheroResultante := suprimirNumeros (ficheroResultante);

      if regla = 'Todo en maysculas' then
        ficheroResultante := todoEnMayusculas (ficheroResultante);

      if regla = 'Todo en minsculas' then
        ficheroResultante := todoEnMinusculas (ficheroResultante);
    end;
    ficheroResultante := ficheroResultante + '.' + extensionResultante;
    txtResultado.text := ficheroResultante;
  except
    txtResultado.Text := 'Error en aplicacin de filtro';
  end;
end;

procedure TformFiltros.actNuevoFiltroExecute(Sender: TObject);
begin
  formSeleccionFiltros.ShowModal;
end;

procedure TformFiltros.actAceptarExecute(Sender: TObject);
begin
  if txtCombinacion.Text <> '' then
  begin
    if guardarCombinacionFiltros (txtCombinacion.Text, tabla.Strings) then
      close
    else
      txtCombinacion.SetFocus;
  end
  else
  begin
    actGuardarCombinacionComoExecute(nil);
    close;
  end;
end;

procedure TformFiltros.actCargarCombinacionExecute(Sender: TObject);
begin
  if txtCombinacion.Text <> '' then
    if not FileExists(ExtractFilePath(Application.ExeName) + txtCombinacion.Text + '.flt') then
      MessageDlg('No se ha encontrado la combinacin de filtros: ' + chr(13) +
          chr(13) + ExtractFilePath(Application.ExeName) + txtCombinacion.Text +
          '.flt', mtWarning, [mbok], 0)
    else
      tabla.Strings.LoadFromFile(ExtractFilePath(Application.ExeName) + txtCombinacion.Text + '.flt')
  else
  begin
    MessageDlg('Debe especificar el nombre de la combinacin a cargar.',
        mtInformation, [mbok], 0);
    txtCombinacion.SetFocus;
  end;
end;

procedure TformFiltros.FormShow(Sender: TObject);
begin
  actCargarCombinacionExecute(nil);
  aplicarFiltrosEjemplo;
//  txtCombinacion.Items := cargarCombinacionFiltros ('');
end;

procedure TformFiltros.actEliminarFiltroExecute(Sender: TObject);
begin
  try
    if tabla.RowCount > 1 then
      tabla.DeleteRow(tabla.Row);
  except
    //silenciosa
  end;
  aplicarFiltrosEjemplo;  
end;

procedure TformFiltros.actGuardarCombinacionExecute(Sender: TObject);
begin
  if txtCombinacion.Text <> '' then
    guardarCombinacionFiltros (txtCombinacion.Text, tabla.Strings)
  else
    actGuardarCombinacionComoExecute(nil);
end;

procedure TformFiltros.actEliminarTodosExecute(Sender: TObject);
begin
  tabla.Strings.Clear;
  aplicarFiltrosEjemplo;
end;

procedure TformFiltros.actCargarCombinacionUbicacionExecute(
  Sender: TObject);
var
  resultado : LongBool;
begin
  dlAbrir.Filter := 'Combinacin filtros (*.flt)|*.flt|Todos los archivos (*.*)|*.*';
  dlAbrir.Title := 'Seleccione la combinacin de filtros a cargar';
  if dlAbrir.Execute then
  begin
    resultado := CopyFile(pchar(dlAbrir.FileName), pchar(ExtractFilePath(Application.ExeName) + ExtractFileName(dlAbrir.FileName)), true);
    if not resultado then
      MessageDlg('El filtro: ' + dlAbrir.FileName + ' no ha podido exportarse. Es posible que ya exista un filtro con el mismo nombre.', mtWarning, [mbok], 0)
    else
    begin
      txtCombinacion.Items := cargarCombinacionFiltros (extraerSoloNombreFichero (dlAbrir.FileName));
      txtCombinacion.ItemIndex := posicionCombinacionDefecto;
    end;
  end;
  aplicarFiltrosEjemplo;  
end;

procedure TformFiltros.actGuardarCombinacionComoExecute(Sender: TObject);
begin
  textoSeleccionado := '';
  formValor.Tag := 200;
  formvalor.showmodal;
  if textoSeleccionado <> '' then
  begin
    guardarCombinacionFiltros(textoSeleccionado, tabla.Strings);
    Application.ProcessMessages;
    txtCombinacion.Items := cargarCombinacionFiltros (textoSeleccionado);
    if posicionCombinacionDefecto <> 0 then
      txtCombinacion.ItemIndex := posicionCombinacionDefecto;
  end;
end;

procedure TformFiltros.tablaStringsChange(Sender: TObject);
begin
  aplicarFiltrosEjemplo;
end;

procedure TformFiltros.txtEjemploChange(Sender: TObject);
begin
  aplicarFiltrosEjemplo;
end;

end.
